#  openMat Python - A import and export library 
#  for the openMat database format
#
#  Copyright (C) 2012 Stefan Drechsler
#
# ##### BEGIN GPL LICENSE BLOCK #####
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 3 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General
#  Public License along with this library; if not, write to the
#  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#  Boston, MA 02110-1301 USA
#
# ##### END GPL LICENSE BLOCK #####


import xml.dom.minidom as dom

class File(object):
    
    def __init__(self, keyOrNode):
        if isinstance(keyOrNode, dom.Node):
            self.initFromXml(keyOrNode)
        else:
            self.initFromArgs(keyOrNode)
            
    def initFromArgs(self, inKey):
        self.__content = None
        self.__keyTag
        self.setKey(inKey)

    def initFromXml(self, node):
        if node.hasAttribute('keyTag'):
            self.setKey(node.getAttribute('keyTag'))
        else:
            print('Error: additional file keyTag Attribute is missing.')
        self.setContent(node.firstChild.data.strip())
        
    def setContent(self, text):
        self.__content = text

    def getContent(self):
        return self.__content
    
    def setKey(self, key):
        self.__keyTag = key
        
    def getKey(self):
        return self.__keyTag

    def getAsXml(self, tagName):
        tagFile = dom.Element(tagName)
        tagFile.setAttribute('keyTag', self.__keyTag)
        text = dom.Text()
        text.data = self.__content
        tagFile.appendChild(text)
        return tagFile

